aboutsummaryrefslogtreecommitdiffstats
path: root/util/grub.d/10_kfreebsd.in
diff options
context:
space:
mode:
Diffstat (limited to 'util/grub.d/10_kfreebsd.in')
-rw-r--r--util/grub.d/10_kfreebsd.in192
1 files changed, 192 insertions, 0 deletions
diff --git a/util/grub.d/10_kfreebsd.in b/util/grub.d/10_kfreebsd.in
new file mode 100644
index 0000000..3600c74
--- /dev/null
+++ b/util/grub.d/10_kfreebsd.in
@@ -0,0 +1,192 @@
+#! /bin/sh
+set -e
+
+# grub-mkconfig helper script.
+# Copyright (C) 2006,2007,2008,2009,2010 Free Software Foundation, Inc.
+#
+# GRUB is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# GRUB is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
+
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+bindir=@bindir@
+libdir=@libdir@
+. ${libdir}/grub/grub-mkconfig_lib
+
+export TEXTDOMAIN=@PACKAGE@
+export TEXTDOMAINDIR=@localedir@
+
+CLASS="--class os"
+
+case "${GRUB_DISTRIBUTOR}" in
+ Debian)
+ OS="${GRUB_DISTRIBUTOR} GNU/kFreeBSD"
+ CLASS="--class $(echo ${GRUB_DISTRIBUTOR} | tr 'A-Z' 'a-z' | cut -d' ' -f1) --class gnu-kfreebsd --class gnu ${CLASS}"
+ ;;
+ *)
+ OS="FreeBSD"
+ CLASS="--class freebsd --class bsd ${CLASS}"
+ ;;
+esac
+
+load_kfreebsd_module ()
+{
+ mod="$1"
+ allow_fail="$2"
+
+ if ! test -e "${module_dir}/${mod}.ko" ; then
+ if [ "${allow_fail}" = "true" ] ; then
+ # Return silently
+ return
+ else
+ # Print an error and fail.
+ ls "${module_dir}/${mod}.ko" > /dev/null
+ fi
+ fi
+
+ if [ -z "${prepare_module_dir_cache}" ]; then
+ prepare_module_dir_cache="$(prepare_grub_to_access_device $(grub-probe -t device "${module_dir}") | sed -e "s/^/\t/")"
+ fi
+
+ printf '%s\n' "${prepare_module_dir_cache}"
+ cat << EOF
+ kfreebsd_module_elf ${module_dir_rel}/${mod}.ko
+EOF
+}
+
+kfreebsd_entry ()
+{
+ os="$1"
+ version="$2"
+ recovery="$3"
+ args="$4"
+ if ${recovery} ; then
+ title="$(gettext_quoted "%s, with kFreeBSD %s (recovery mode)")"
+ else
+ title="$(gettext_quoted "%s, with kFreeBSD %s")"
+ fi
+ printf "menuentry '${title}' ${CLASS} {\n" "${os}" "${version}"
+ if ! ${recovery} ; then
+ save_default_entry | sed -e "s/^/\t/"
+ fi
+ if [ -z "${prepare_boot_cache}" ]; then
+ prepare_boot_cache="$(prepare_grub_to_access_device ${GRUB_DEVICE_BOOT} | sed -e "s/^/\t/")"
+ fi
+
+ printf '%s\n' "${prepare_boot_cache}"
+ message="$(gettext_printf "Loading kernel of FreeBSD %s ..." ${version})"
+ cat << EOF
+ echo '$message'
+ kfreebsd ${rel_dirname}/${basename} ${args}
+EOF
+
+ if test -n "${devices}" ; then
+ cat << EOF
+ kfreebsd_loadenv ${devices_rel_dirname}/${devices_basename}
+EOF
+ fi
+
+ load_kfreebsd_module acpi true
+
+ case "${kfreebsd_fs}" in
+ zfs)
+ load_kfreebsd_module opensolaris false
+
+ ls "${dirname}/zfs/zpool.cache" > /dev/null
+ printf '%s\n' "${prepare_boot_cache}"
+ cat << EOF
+ kfreebsd_module ${rel_dirname}/zfs/zpool.cache type=/boot/zfs/zpool.cache
+EOF
+ ;;
+ esac
+
+ if [ x${kfreebsd_fs} = xufs ]; then
+ load_kfreebsd_module ${kfreebsd_fs} true
+ else
+ load_kfreebsd_module ${kfreebsd_fs} false
+ fi
+
+ cat << EOF
+ set kFreeBSD.vfs.root.mountfrom=${kfreebsd_fs}:${kfreebsd_device}
+ set kFreeBSD.vfs.root.mountfrom.options=rw
+}
+EOF
+}
+
+list=`for i in /boot/kfreebsd-* /boot/kernel/kernel ; do
+ if grub_file_is_not_garbage "$i" ; then echo -n "$i " ; fi
+ done`
+prepare_boot_cache=
+
+while [ "x$list" != "x" ] ; do
+ kfreebsd=`version_find_latest $list`
+ echo "Found kernel of FreeBSD: $kfreebsd" >&2
+ basename=`basename $kfreebsd`
+ dirname=`dirname $kfreebsd`
+ rel_dirname=`make_system_path_relative_to_its_root $dirname`
+
+ if [ -f /boot/device.hints ] ; then
+ devices=/boot/device.hints
+ devices_basename=`basename $devices`
+ devices_dirname=`dirname $devices`
+ devices_rel_dirname=`make_system_path_relative_to_its_root $devices_dirname`
+ fi
+
+ case ${GRUB_FS} in
+ ufs1 | ufs2) kfreebsd_fs=ufs ;;
+ ext2) kfreebsd_fs=ext2fs ;;
+ *) kfreebsd_fs=${GRUB_FS} ;;
+ esac
+
+ case ${GRUB_FS} in
+ zfs)
+ # zpool name
+ kfreebsd_device=$(grub-probe -t fs_label --device ${GRUB_DEVICE})
+ # filesystem name (empty string for the main filesystem)
+ kfreebsd_device="${kfreebsd_device}$(grub-mkrelpath / | sed -e "s,/*@$,,")"
+ ;;
+ *)
+ kfreebsd_device=${kfreebsd_fs}id/${GRUB_DEVICE_UUID}
+ # Debian GNU/kFreeBSD can't remount root if it's supplied as UUID but
+ # as an UUID
+ if [ "x${GRUB_DISTRIBUTOR}" = "xDebian" ] \
+ && ! (cat /etc/fstab | awk '!/^[[:space:]]*#/ && $2=="/" { print $1; }' \
+ | grep "${kfreebsd_fs}id/${GRUB_DEVICE_UUID}" > /dev/null); then
+ kfreebsd_device=${GRUB_DEVICE}
+ fi
+ ;;
+ esac
+
+ version=`echo $basename | sed -e "s,^[^0-9]*-,,g;s/\.gz$//g"`
+ alt_version=`echo $version | sed -e "s,\.old$,,g"`
+
+ module_dir=
+ for i in "/lib/modules/${version}" "/lib/modules/${alt_version}" \
+ "/boot/kernel"; do
+ if test -e "$i" ; then
+ module_dir="$i"
+ break
+ fi
+ done
+ if test -n "${module_dir}" ; then
+ echo "Found kernel module directory: ${module_dir}" >&2
+ module_dir_rel=$(make_system_path_relative_to_its_root $module_dir)
+ fi
+
+ kfreebsd_entry "${OS}" "${version}" false
+ if [ "x${GRUB_DISABLE_RECOVERY}" != "xtrue" ]; then
+ kfreebsd_entry "${OS}" "${version}" true "-s"
+ fi
+
+ list=`echo $list | tr ' ' '\n' | grep -vx $kfreebsd | tr '\n' ' '`
+done